#! /usr/bin/env python
# -*- coding: utf-8 -*-
# vim:fenc=utf-8

from __future__ import unicode_literals

"""
Test script to peek in db files.
"""

import struct
import os
import mmap

filename = 'metrics/gauge_livesum_40272.db'
f = open(filename, 'a+b')
capacity = os.fstat(f.fileno()).st_size
m = mmap.mmap(f.fileno(), capacity)
used = struct.unpack_from(b'i', m, 0)[0]

pos = 8
while pos < used:
  encoded_len = struct.unpack_from(b'i', m, pos)[0]
  pos += 4
  encoded = struct.unpack_from('{0}s'.format(encoded_len).encode(), m, pos)[0]
  padded_len = encoded_len + (8 - (encoded_len + 4) % 8)
  pos += padded_len
  value = struct.unpack_from(b'd', m, pos)[0]
  print("Entry: %s = %d" % (encoded, value))
  pos += 8

f.close()

print("Capacity %s" % capacity)
print("Used %d" % used)
